Subject: Re: [patch 02/10] powerpc: Move CONFIG_PPC64 into CPU selection

From: Segher Boessenkool <[email-masked]>
Date: Wed, 13 Jun 2007 06:57:41 +0200

>> It would be good to converge the 32- and 64-bit implementations,
>> and/or allow a single kernel image to work on both 32-bit and
>> 64-bit systems,  The current situation is far removed from that,
>> so this patch is a bit premature in that aspect.
>
> There will always be differences in emphasis and focus between 32-bit
> and 64-bit.  For example, the vast majority of 32-bit systems are UP,
> with a few 2-way SMP systems, an insignificant number of 4-way
> systems, and nothing bigger than 4-way.  In contrast, most 64-bit
> machines are SMP, with enough large SMP machines (64-way and bigger)
> to be worth worrying about.  Hence the 64-bit code focuses on SMP
> scalability whereas the 32-bit code focuses on performance for UP and
> 2-way systems - which is why the hash table invalidations get batched
> up on 64-bit machines but not on 32-bit machines, for instance.
> Similarly, 64-bit supports large memory (>4GB) and NUMA machines,
> whereas 32-bit doesn't.

While all this is certainly true, there still are many
differences between 32-bit and 64-bit that aren't really
warranted.  Also, things like the scalability "knobs"
should perhaps not be directly keyed of the PPC64 symbol.

Anyway, nothing to worry about now I guess ;-)

Segher